//
//  TEAppDelegate.swift
//  TextEditDoc
//
//  Created by narita on 2017/12/25.
//  Copyright © 2017年 narita. All rights reserved.
//

import Cocoa

@NSApplicationMain
class TEAppDelegate: NSObject, NSApplicationDelegate
{
    // MARK: - class methods
    
    // MARK: - init methods
    
    // MARK: - dealloc
    
    // MARK: - NSCopying, hash, isEqual:
    
    // MARK: - NSCoding methods
    
    // MARK: - restorableState methods
    
    // MARK: - life cycle methods
    
    // MARK: - action methods
    
    func newDocumentOfType(ofType typeName: String)  -> TESingleDocument
    {
        var theDocument: TESingleDocument
        
        do
        {
            theDocument = try NSDocumentController.shared.makeUntitledDocument(ofType: typeName as String) as! TESingleDocument
            
            NSDocumentController.shared.addDocument(theDocument)
            theDocument.makeWindowControllers()
            theDocument.showWindows()
            
            return theDocument
        }
        catch
        {
            NSException(
                name: NSExceptionName.invalidArgumentException,
                reason: "\(typeName) is not a recognized document type.").raise()
        }
    
        return TESingleDocument()// ここにきてはいけない。書き方を考える事。
    }
    
    @IBAction func newPlaneTextDocument(_ sender: NSObject)
    {
        let theDocument = self.newDocumentOfType(ofType: kUTTypePlainText as String)
        theDocument.isRichText = false
    }
    
    @IBAction func newRTFDocument(_ sender: NSObject)
    {
        let theDocument = self.newDocumentOfType(ofType: kUTTypeRTF as String)
        theDocument.isRichText = true
    }
    
    @IBAction func newRTFDTextDocument(_ sender: NSObject)
    {
        let theDocument = self.newDocumentOfType(ofType: kUTTypeRTFD as String)
        theDocument.isRichText = true
    }
    
    @IBAction func newHTMLDocument(_ sender: NSObject)
    {
        let theDocument = self.newDocumentOfType(ofType: kUTTypeHTML as String)
        theDocument.isRichText = true
    }
    
    @IBAction func newWebArchiveDocument(_ sender: NSObject)
    {
        let theDocument = self.newDocumentOfType(ofType: kUTTypeWebArchive as String)
        theDocument.isRichText = true
    }
    
    // MARK: - event handling methods
    
    // MARK: - drawing methods
    
    // MARK: - delegate/datasource methods

    func applicationDidFinishLaunching(_ aNotification: Notification)
    {
        // Insert code here to initialize your application
    }

    func applicationWillTerminate(_ aNotification: Notification)
    {
        // Insert code here to tear down your application
    }
    
    // MARK: - accessor methods (in pairs)
    
    // MARK: - Utility methods

}
