//
//  TEAppDelegate.swift
//  TextEditDoc
//
//  Created by narita on 2017/12/25.
//  Copyright © 2017年 narita. All rights reserved.
//

import Cocoa

@NSApplicationMain
class TEAppDelegate: NSObject, NSApplicationDelegate
{
    // MARK: - class methods
    
    // MARK: - init methods
    
    // MARK: - dealloc
    
    // MARK: - NSCopying, hash, isEqual:
    
    // MARK: - NSCoding methods
    
    // MARK: - restorableState methods
    
    // MARK: - life cycle methods
    
    // MARK: - action methods
    
    func newDocumentOfType(ofType typeName: String)
    {
        do
        {
            let theDocument: NSDocument = try NSDocumentController.shared.makeUntitledDocument(ofType: typeName as String)
            
            NSDocumentController.shared.addDocument(theDocument)
            theDocument.makeWindowControllers()
            theDocument.showWindows()
        }
        catch
        {
            NSException(
                name: NSExceptionName.invalidArgumentException,
                reason: "\(typeName) is not a recognized document type.").raise()
        }
    }
    
    @IBAction func newPlaneTextDocument(_ sender: NSObject)
    {
        self.newDocumentOfType(ofType: kUTTypePlainText as String)
    }
    
    @IBAction func newRTFDocument(_ sender: NSObject)
    {
        self.newDocumentOfType(ofType: kUTTypeRTF as String)
    }
    
    @IBAction func newRTFDTextDocument(_ sender: NSObject)
    {
        self.newDocumentOfType(ofType: kUTTypeRTFD as String)
    }
    
    @IBAction func newHTMLDocument(_ sender: NSObject)
    {
        self.newDocumentOfType(ofType: kUTTypeHTML as String)
    }
    
    @IBAction func newWebArchiveDocument(_ sender: NSObject)
    {
        self.newDocumentOfType(ofType: kUTTypeWebArchive as String)
    }
    
    // 以下のメソッドでテンプレートからの作成を使える。
    /* Instantiate a document, perhaps located by a URL, perhaps not, by reading the contents for the document from another URL, which may or may not be a different URL, and return it if successful. If not successful, return nil after setting *outError to an NSError that encapsulates the reason why the document could not be instantiated. The default implementation of this method invokes -documentClassForType: to find out the class of document to instantiate, allocates a document object, and initializes it by sending it an -initForURL:withContentsOfURL:ofType:error: message.
     */
    // open func makeDocument(for urlOrNil: URL?, withContentsOf contentsURL: URL, ofType typeName: String) throws -> NSDocument
    
    
    

    // MARK: - event handling methods
    
    // MARK: - drawing methods
    
    // MARK: - delegate/datasource methods

    func applicationDidFinishLaunching(_ aNotification: Notification)
    {
        // Insert code here to initialize your application
    }

    func applicationWillTerminate(_ aNotification: Notification)
    {
        // Insert code here to tear down your application
    }
    
    // MARK: - accessor methods (in pairs)
    
    // MARK: - Utility methods

}
