//
//  TEViewController.swift
//  TextEditDoc
//
//  Created by narita on 2017/12/25.
//  Copyright © 2017年 narita. All rights reserved.
//

import Cocoa

class TEViewController: NSViewController, NSTextViewDelegate
{
    // MARK: - class methods
    
    // MARK: - init methods
    
    // MARK: - dealloc
    
    // MARK: - NSCopying, hash, isEqual:
    
    // MARK: - NSCoding methods
    
    // MARK: - restorableState methods
    
    // MARK: - life cycle methods

    override func viewDidLoad()
    {
        super.viewDidLoad()        
    }

    // MARK: - action methods
    
    // MARK: - event handling methods
    
    @objc func changeRichText(isRichText: Bool)
    {
        if isRichText
        {
            self.textView?.isRichText = isRichText
            self.textView?.usesInspectorBar = isRichText
        }
        else
        {
            self.textView?.isRichText = isRichText
            self.textView?.usesInspectorBar = isRichText
        }
    }
    
    // MARK: - drawing methods
    
    // MARK: - delegate/datasource methods
    
    // MARK: - accessor methods (in pairs)

    @IBOutlet var textView: NSTextView? = nil

    @objc var richObservation: NSKeyValueObservation? = nil   // KVOでisRichの監視

    override var representedObject: Any?
    {
        didSet
        {
            // Update the view, if already loaded.
            if let theDocument = representedObject as! TESingleDocument?
            {
                self.textView!.layoutManager?.replaceTextStorage(theDocument.textStorage!)
                
                // file形式によって異なる...theDocumentの値で切り替える
                //self.textView!.isRichText = theDocument.isRichText
                self.changeRichText(isRichText: theDocument.isRichText)
                
                // richTextの値で、self.textView.isRichTextを書き換える為に、representedObject!.isRitchにKVOを引っ掛ける
                self.richObservation = theDocument.observe( \.isRichText )
                { _,_ in
                    self.changeRichText(isRichText: theDocument.isRichText)
                }
            }
        }
    }

    // MARK: - Utility methods

}

